#!/usr/bin/perl

$mailprog        = '/usr/sbin/sendmail';
$agent           = 'Dimke Web2Mail v.1.0 (C) 2007 Klein Dimke';
require            '/full/path/to/web2mail.cfg';

#   ### Never change any parameter below here ##################################

use LWP::UserAgent;
$header = new HTTP::Headers;
$header->user_agent($agent);
$uagent = new LWP::UserAgent;
$req = new HTTP::Request ("HEAD" => $file, $header);
$result = $uagent->request($req);
$modified_new = $result->last_modified;

open HEADINFO, "$headerinfo_file";
    $modified_old=<HEADINFO>;
close HEADINFO;

if ($modified_new eq '') {
    print "Fehler: HTTP HEAD gesperrt!\n";
    print "Abnormales Programmende.\n";
    print "NOT OK.\n";
    exit;
}

if ($modified_new eq $modified_old) {
    # Requested file not modified.
    # Exit.
    exit;
}

$ua = new LWP::UserAgent;
$ua->agent($agent);
$req = new HTTP::Request 'GET', $file;
$req-> header('Accept' => 'text/html');
$result_new = $ua->request($req)->content;

if ($result_new eq '') {
    print "Fehler: Gewuenschte Datei nicht verfuegbar!\n";
    print "Abnormales Programmende.\n";
    print "NOT OK.\n";
    exit;
}

#   ### Preparing Email ########################################################

$plain_text = $result_new;
$plain_text =~ s/\r//g;
$plain_text =~ s/([\w\.\,\:\;\-\_])\n/$1 /g;
$plain_text =~ s/\n//g;
$plain_text =~ s/<br>/\n/gi;
$plain_text =~ s/<p>/\n\n/gi;
$plain_text =~ s/\&nbsp\;/   /g;
$plain_text =~ s/\&auml\;/\/g;
$plain_text =~ s/\&ouml\;/\/g;
$plain_text =~ s/\&uuml\;/\/g;
$plain_text =~ s/\&Auml\;/\/g;
$plain_text =~ s/\&Ouml\;/\/g;
$plain_text =~ s/\&Uuml\;/\/g;
$plain_text =~ s/\&szlig\;/\/g;
$plain_text =~ s/\&sect\;/\/g;
$plain_text =~ s/<.*?>//g;
$plain_text =~ s/<!--.*?-->//gs;

open(EmailFile,$bcc_file) or die "Couldn't open $bcc_file: $!\n";
@emails=<EmailFile>;
close(EmailFile);
$BccField='';
foreach $i (@emails) {
   chomp($i);
   $BccField .= "$i,";
}
close(EmailFile);

open (MAIL, "|$mailprog -t") || die "Can't open $mailprog!\n";
print MAIL "From: $from\n";
print MAIL "Reply-to: $from\n";
print MAIL "To: $recipient\n";
print MAIL "Bcc: $BccField\n";
print MAIL "X-Priority: 1\n";
print MAIL "Subject: $subject\n";
print MAIL "MIME-Version: 1.0\n";
print MAIL "Content-Type: text/plain; charset=\"iso-8859-1\"\n\n";

print MAIL "################################################################################\n";
print MAIL "#\n";
print MAIL "# Textausgabe der originalen Seite: $file\n";
print MAIL "#\n";
print MAIL "################################################################################\n";
print MAIL "\n\n";
print MAIL "$plain_text";
print MAIL "\n";

close (MAIL);

open HEADINFO, ">$headerinfo_file";
    print HEADINFO $modified_new;
close HEADINFO;

exit;
